function servercmdRoBAdmin(%client, %target)
{
	if(!%client.issuperadmin) return;
	
	if(%client.robadmin){
		%client.robadmin = false;
		if(isObject(%client.player)) %client.player.setdatablock(PlayerRoB);
		//%client.player.setrechargerate(0);
		schedule(100, 0, "SetPlayerEnergy", %client.player);
		%client.applybodyparts();
		%client.applybodycolors();
		messageclient(%client, "", "\c6RoBAdmin \c0OFF\c6.");
		cancel(%client.robadminrem);
		//%client.player.tool[3] = 0;
		//messageClient(%client, 'MsgItemPickup', '', 3, 0);
	} else {
		%client.robadmin = true;
		if(isObject(%client.player)) %client.player.setdatablock(PlayerStandardArmor);
		%client.applybodyparts();
		%client.applybodycolors();
		messageclient(%client, "", "\c6RoBAdmin \c0ON\c6.");
		%client.robadminrem = schedule(60000, 0, "RoBAdminReminder", %client);
		//%client.player.tool[3] = nametoID(wrenchItem);
		//messageClient(%client, 'MsgItemPickup', '', 3, nametoID(wrenchItem));
	}
}

function RoBAdminReminder(%client)
{
	if(!%client.robadmin) return;
	messageclient(%client, "", "\c7REMINDER: RoBAdmin is still active.");
	%client.robadminrem = schedule(60000, 0, "RoBAdminReminder", %client);
}

function servercmdrobgamestart(%admin)
{
	if(!%admin.robadmin || $RoB::Dynamic::GameStarted) return;
	$RoB::Dynamic::GameStarted = true;
	$RoB::LoadComplete = true;
	messageclient(%admin, "", "GAME INITIATED; BUSINESSES NOW PRODUCING.");
	$RoB::Dynamic::ProdRateStep = 0.25;
	$RoB::Dynamic::CoreCashRate = 1.19; //cash rate step is assumed to be in the same ratio as prodratestep to coreprodrate
	//RoBTick(10);
	AddEvent("gamestart: Game proper started.");
}

function servercmdNewPlot(%client)
{
	if(!%client.robadmin || !isobject(%client.player)) return;
	%plot = findPlotFromObject(%client.getcontrolobject());
	%ret = RoBNewPlot(%plot);
	switch$(%ret)
	{
		case "ROAD":
			messageclient(%client, "", "THIS IS A ROAD SECTION; NO ACTION.");
		case "EXISTS":
			messageclient(%client, "", "THIS PLOT EXISTS ALREADY; NO ACTION.");
		case "GOOD":
			messageclient(%client, "", "PLOT CREATED, BUILD ROADS.");
	}

	%time = getDateTime();
	%ETS = (360 - ((getsubstr(%time, 12, 2) % 6) * 60) - getsubstr(%time, 15, 2) + 1) * 1000;
	if(!isEventPending($RoB::TickSchedule)) $RoB::TickSchedule = schedule(%ETS,0,"RoBTick",10);	
}

function servercmdroadname(%admin, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j)
{
	if(!%admin.robadmin || !isobject(%admin.player)) return;
	%name = rtrim(%a SPC %b SPC %c SPC %d SPC %e SPC %f SPC %g SPC %h SPC %i SPC %j);
	%plot = findPlotFromObject(%admin.player);
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	if(strpos(%x, "to", 0) != -1) {
		if(strpos(%y, "to", 0) != -1) {
			messageclient(%admin, "", "CAN'T NAME INTERSECTIONS.");
		} else {
			%tmp = $RoB::RoadName[x, %x];
			$RoB::RoadName[x, %x] = %name;
			if(%tmp $= "") messageclient(%admin, "", "ROAD IS NOW NAMED: \c6" @ %name);
			else messageclient(%admin, "", "\c7" @ %tmp @ " \c0NAME CHANGED TO: \c6" @ %name);
		}
	} else {
		if(strpos(%y, "to", 0) != -1) {
			%tmp = $RoB::RoadName[y, %y];
			$RoB::RoadName[y, %y] = %name;		
			if(%tmp $= "") messageclient(%admin, "", "ROAD IS NOW NAMED: \c6" @ %name);
			else messageclient(%admin, "", "\c7" @ %tmp @ " NAME CHANGED TO: \c6" @ %name);	
		} else {
			messageclient(%admin, "", "THIS IS NOT A ROAD.");
		}
	}
}


	// allows admins to centerprintall.
function serverCmdCenter(%client, %msg, %color) {
	%msg = colorselect(%color) @ strreplace(%msg, "_", " ");
	if((%client.isadmin && !$Pref::Server::MrWCenterSuperOnly) || %client.issuperadmin) centerPrintAll(%msg, 5, 3);
	echo(%client.name @ " centerprinted: " @ %msg);
}

	//allows admins to bottomprintall.
function serverCmdBottom(%client, %msg, %color) {
	%msg = colorselect(%color) @ strreplace(%msg, "_", " ");
	if((%client.isadmin && !$Pref::Server::MrWBottomSuperOnly) || %client.issuperadmin) bottomPrintAll(%msg, 5, 3);
	echo(%client.name @ " bottomprinted: " @ %msg);
}

//converts input "X" into "\cX", useful for the above print-functions.
function colorselect(%color) {
	switch(%color)
	{
		case 0:
			return "\c0";
		case 1:
			return "\c1";
		case 2:
			return "\c2";
		case 3:
			return "\c3";
		case 4:
			return "\c4";
		case 5:
			return "\c5";
		case 7:
			return "\c7";
		default:
			return "\c6"; //white if you messed up
	}
}

function servercmdmute(%admin, %blid)
{
	if(!%admin.isadmin) return;
	%blid = mfloor(%blid);
	%target = findClientByBL_ID(%blid);
	if(%target.isadmin && !%admin.issuperadmin) return;
	if(%target == -1) return;
	$RoB::Muted[%blid] = true;
	messageall("", "\c5Because of a chat rule violation, " @ %admin.name @ " has muted " @ %target.name @ " for 5 minutes.");
	schedule(300000, 0, "despammute", %blid);
}

function robmute(%target)
{
	%target = findClientByName(%target);
	if(%target.isadmin && !%admin.issuperadmin) return;
	if(%target == -1) return;
	$RoB::Muted[%target.bl_id] = true;
	messageall("", "\c5Because of a chat rule violation, " @ %target.name @ " has been muted for 5 minutes.");
	schedule(300000, 0, "despammute", %target.bl_id);
}

function despammute(%blid)
{
	%target = findClientByBL_ID(%blid);
	$RoB::Muted[%blid] = false;
	if(%target == -1) return;
	messageclient(%target, "", "\c1You can speak again.");
}

function servercmdClaimPlot(%admin)
{
	if(!%admin.robadmin || !isobject(%admin.player)) return;
	%plot = findPlotFromObject(%admin.player);
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	if(strpos(%plot, "to", 0) != -1 || !isObject($RoB::Plot[%x, %y])) return;
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().getname() $= "brickProductionData" || %target.getdatablock().getname() $= "brickStorageData" || %target.getdatablock().getname() $= "brickSalePointData" || %target.getdatablock().getname() $= "brickSpawnPointData") {
			%target.killbrick();
		}
	}
	%price += GetCongestionPrice(%plot);
	%finalprice = %price + $RoB::Plot[%x, %y].value;
	%owner = $RoB::Plot[%x, %y].blid;
	$RoB::PData[%owner, money] += %finalprice;
	%totalprod = GetTotalProd(%client.bl_id);
	%unit = mfloor(%totalprod * $RoB::Dynamic::CoreCashRate);
	%playercashcap = $RoB::Dynamic::PlayerCoreRateMax * %unit;
	%playercashamt = %playercashcap - ($RoB::PData[%client.bl_id, cashtimer] * %unit);
	if(%playercashamt < 0) %playercashamt = 0;
	%newunit = mfloor((%totalprod - $RoB::Plot[%x, %y].prodfactor) * $RoB::Dynamic::CoreCashRate);
	%newcap = $RoB::Dynamic::PlayerCoreRateMax * %newunit;
	$RoB::PData[$RoB::Plot[%x, %y].blid, cashtimer] = $RoB::Dynamic::PlayerCoreRateMax - mfloor(%playercashamt / %newunit);
	$RoB::Plot[%x, %y].blid = -1;
	$RoB::Plot[%x, %y].owner = "Repossessed Lot";
	$RoB::Plot[%x, %y].name = %plot;
	%type = $RoB::Plot[%x, %y].type;
	$RoB::Plot[%x, %y].type = "U";
	$RoB::Plot[%x, %y].produced = 0;
	$RoB::Plot[%x, %y].prodfrac = 0;
	%stor = $RoB::Plot[%x, %y].stored;
	$RoB::Plot[%x, %y].stored = 0;
	schedule(200, "RepoCapacityNull", %x, %y);
	$RoB::Plot[%x, %y].price = 15;
	$RoB::Plot[%x, %y].newbiz = false;
	$RoB::Plot[%x, %y].closed = false;
	$RoB::Plot[%x, %y].repoed = true;
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().subcategory $= "Prints" ) %target.setPrint($RoB::APrint);
	}
	
	for(%i = 1; ($RoB::Property[%owner, %i] !$= "" || %i == 1); %i++) {
		%lx = getword($RoB::Property[%owner, %i], 0);
		%ly = getword($RoB::Property[%owner, %i], 1);
		if(%plotfound) $RoB::Property[%owner, (%i - 1)] = $RoB::Property[%owner, %i];
		else if(%mainres && $RoB::Plot[%lx, %ly].type $= "R") {
			$RoB::Property[%owner, 1] = $RoB::Property[%owner, %i];
			%plotfound = true;
		} else if((%lx SPC %ly) $= (%plot)) {
			$RoB::Property[%owner, %i] = "";
			if(%i == 1) %mainres = true;
			else %plotfound = true;
		}
	}
	if(%plotfound) $RoB::Property[%owner, (%i - 1)] = $RoB::Property[%owner, %i];
	
	$RoB::Log[total, plyrplots]--;
	$RoB::Log[total, plotvalue] -= $RoB::Plot[%x, %y].value;
	if($RoB::Log[total, plyrplots] != 0) $RoB::Log[avg, plotvalue] = $RoB::Log[total, plotvalue] / $RoB::Log[total, plyrplots];
	$RoB::Log[avg, plyrplots] = $RoB::Log[total, plyrplots] / $RoB::Log[total, players];
	AddEvent("repossess: (" @ %x @ ", " @ %y @ ") forcefully repossessed by admin (" @ %admin.BL_ID @ ") with " @ %stor SPC %type @ " from (" @ %owner @ ") for $" @ %finalprice @ ".");
	AddWorth(%owner, %stor * -15);
	
	%xa = %x - 1;
	%xb = %x + 1;
	%ya = %y - 1;
	%yb = %y + 1;
	RepoRoad(%xa @ "to" @ %x, %ya @ "to" @ %y, %owner);
	RepoRoad(%xa @ "to" @ %x, %y, %owner);
	RepoRoad(%xa @ "to" @ %x, %y @ "to" @ %yb, %owner);
	RepoRoad(%x, %ya @ "to" @ %y, %owner);
	RepoRoad(%x, %y @ "to" @ %yb, %owner);
	RepoRoad(%x @ "to" @ %xb, %ya @ "to" @ %y, %owner);
	RepoRoad(%x @ "to" @ %xb, %y, %owner);
	RepoRoad(%x @ "to" @ %xb, %y @ "to" @ %yb, %owner);
	
	//for(%cX = %x - 1; %cX <= %x + 1; %cX++) { //TO DO congestion adjustment?
	//	for(%cY = %y - 1; %cY <= %y + 1; %cY++) {
	//		if((%cX != %x || %cY != %y) && $RoB::Plot[%sX, %sY].type !$= "" && $RoB::Plot[%sX, %sY].type !$= "U") {
	//			%C = 0;
	//			for(%sX = %cX - 1; %sX <= %cX + 1; %sX++) {
	//				for(%sY = %cY - 1; %sY <= %cY + 1; %sY++) {
	//					if((%cX != %x || %cY != %y) && $RoB::Plot[%sX, %sY].type !$= "" && $RoB::Plot[%sX, %sY].type !$= "U") {
	//						%C++;
	//					}
	//				}
	//			}
	//			AddWorth($RoB::Plot[%cX, %cY].blid, -1250);
	//		}
	//	}
	//}
	messageclient(%admin, "", "PLOT CLAIMED.");
}
